#!/bin/sh

get_section_offset()
{
    echo 0x`readelf -SW "$1" | grep " $2" | sed -e 's/\[ */\[/' | awk '{print $5}'`
}

get_symbol_offset()
{
    echo 0x`readelf -sW "$1" | grep " $2$" | awk '{print $2}'`
}

get_symbol_num()
{
    readelf -sW "$1" | grep " $2$" | sed -e 's/:.*//'
}

get_file_offset()
{
    sec=`get_section_offset $1 $2`
    sym=`get_symbol_offset $1 $3`
    echo $(($sec + $sym))
}

global_symbol()
{
    num=`get_symbol_num $1 $2`
    sec=`get_section_offset $1 ".symtab"`
    off=$(($sec + $num * 0x10 + 0xc))

    printf "sec:%x num:%x off:%x\n" $sec $num $off
    perl -e "print pack('c', 0x12);" | dd of=$1 bs=1 seek=$off count=1 conv=notrunc 2> /dev/null
}

global_symbol $1 "pxa_sd_put_command"
global_symbol $1 "pxa_sd_opendrain_command"
exit 0;
